/* A Bison parser, made by GNU Bison 3.0.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2013 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
#line 24 "../../smtpd/parse.y" /* yacc.c:339  */

#include "includes.h"

#include <sys/types.h>
#include <sys/time.h>
#include <sys/queue.h>
#include <sys/tree.h>
#include <sys/socket.h>
#include <sys/stat.h>
#include <sys/ioctl.h>

#include <net/if.h>
#include <netinet/in.h>
#include <arpa/inet.h>

#include <ctype.h>
#include <err.h>
#include <errno.h>
#include <event.h>
#include <ifaddrs.h>
#include <imsg.h>
#include <inttypes.h>
#include <limits.h>
#include <netdb.h>
#include <paths.h>
#include <pwd.h>
#include <stdarg.h>
#include <resolv.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <syslog.h>
#include <unistd.h>
#ifdef HAVE_UTIL_H
#include <util.h>
#endif

#include <openssl/ssl.h>

#include "smtpd.h"
#include "ssl.h"
#include "log.h"

TAILQ_HEAD(files, file)		 files = TAILQ_HEAD_INITIALIZER(files);
static struct file {
	TAILQ_ENTRY(file)	 entry;
	FILE			*stream;
	char			*name;
	int			 lineno;
	int			 errors;
} *file, *topfile;
struct file	*pushfile(const char *, int);
int		 popfile(void);
int		 check_file_secrecy(int, const char *);
int		 yyparse(void);
int		 yylex(void);
int		 kw_cmp(const void *, const void *);
int		 lookup(char *);
int		 lgetc(int);
int		 lungetc(int);
int		 findeol(void);
int		 yyerror(const char *, ...)
    __attribute__ ((format (printf, 1, 2)))
    __attribute__((__nonnull__ (1)));

TAILQ_HEAD(symhead, sym)	 symhead = TAILQ_HEAD_INITIALIZER(symhead);
struct sym {
	TAILQ_ENTRY(sym)	 entry;
	int			 used;
	int			 persist;
	char			*nam;
	char			*val;
};
int		 symset(const char *, const char *, int);
char		*symget(const char *);

struct smtpd		*conf = NULL;
static int		 errors = 0;

struct filter_conf	*filter = NULL;
struct table		*table = NULL;
struct rule		*rule = NULL;
struct listener		 l;
struct mta_limits	*limits;
static struct pki	*pki;
static struct ca	*sca;

enum listen_options {
	LO_FAMILY		= 0x000001,
	LO_PORT			= 0x000002,
	LO_SSL			= 0x000004,
	LO_FILTER		= 0x000008,
	LO_PKI			= 0x000010,
	LO_AUTH			= 0x000020,
	LO_TAG			= 0x000040,
	LO_HOSTNAME		= 0x000080,
	LO_HOSTNAMES		= 0x000100,
	LO_MASKSOURCE		= 0x000200,
	LO_NODSN		= 0x000400,
	LO_SENDERS		= 0x000800,
	LO_RECEIVEDAUTH		= 0x001000,
	LO_MASQUERADE		= 0x002000,
	LO_DSNNOTIFY_DISABLE	= 0x004000,
	LO_DSNRET_HEADERS	= 0x008000,
	LO_CA			= 0x010000,
};

static struct listen_opts {
	char	       *ifx;
	int		family;
	in_port_t	port;
	uint16_t	ssl;
	char	       *filtername;
	char	       *pki;
	char	       *ca;
	uint16_t       	auth;
	struct table   *authtable;
	char	       *tag;
	char	       *hostname;
	struct table   *hostnametable;
	struct table   *sendertable;
	uint16_t	flags;

	uint32_t       	options;
} listen_opts;

static void	create_listener(struct listenerlist *,  struct listen_opts *);
static void	config_listener(struct listener *,  struct listen_opts *);

struct listener	*host_v4(const char *, in_port_t);
struct listener	*host_v6(const char *, in_port_t);
int		 host_dns(struct listenerlist *, struct listen_opts *);
int		 host(struct listenerlist *, struct listen_opts *);
int		 interface(struct listenerlist *, struct listen_opts *);
void		 set_local(const char *);
void		 set_localaddrs(struct table *);
int		 delaytonum(char *);
int		 is_if_in_group(const char *, const char *);

static struct filter_conf *create_filter_proc(char *, char *);
static struct filter_conf *create_filter_chain(char *);
static int add_filter_arg(struct filter_conf *, char *);

typedef struct {
	union {
		int64_t		 number;
		struct table	*table;
		char		*string;
		struct host	*host;
		struct mailaddr	*maddr;
	} v;
	int lineno;
} YYSTYPE;


#line 222 "../../smtpd/parse.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif


/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    AS = 258,
    QUEUE = 259,
    COMPRESSION = 260,
    ENCRYPTION = 261,
    MAXMESSAGESIZE = 262,
    MAXMTADEFERRED = 263,
    LISTEN = 264,
    ON = 265,
    ANY = 266,
    PORT = 267,
    EXPIRE = 268,
    TABLE = 269,
    SECURE = 270,
    SMTPS = 271,
    CERTIFICATE = 272,
    DOMAIN = 273,
    BOUNCEWARN = 274,
    LIMIT = 275,
    INET4 = 276,
    INET6 = 277,
    NODSN = 278,
    SESSION = 279,
    RELAY = 280,
    BACKUP = 281,
    VIA = 282,
    DELIVER = 283,
    TO = 284,
    LMTP = 285,
    MAILDIR = 286,
    MBOX = 287,
    HOSTNAME = 288,
    HOSTNAMES = 289,
    ACCEPT = 290,
    REJECT = 291,
    INCLUDE = 292,
    ERROR = 293,
    MDA = 294,
    FROM = 295,
    FOR = 296,
    SOURCE = 297,
    MTA = 298,
    PKI = 299,
    SCHEDULER = 300,
    ARROW = 301,
    AUTH = 302,
    TLS = 303,
    LOCAL = 304,
    VIRTUAL = 305,
    TAG = 306,
    TAGGED = 307,
    ALIAS = 308,
    FILTER = 309,
    KEY = 310,
    CA = 311,
    DHPARAMS = 312,
    AUTH_OPTIONAL = 313,
    TLS_REQUIRE = 314,
    USERBASE = 315,
    SENDER = 316,
    SENDERS = 317,
    MASK_SOURCE = 318,
    VERIFY = 319,
    FORWARDONLY = 320,
    RECIPIENT = 321,
    CIPHERS = 322,
    CURVE = 323,
    RECEIVEDAUTH = 324,
    MASQUERADE = 325,
    DSNNOTIFY = 326,
    DISABLE = 327,
    DSNRET = 328,
    HEADERS = 329,
    ENQUEUER = 330,
    STRING = 331,
    NUMBER = 332
  };
#endif
/* Tokens.  */
#define AS 258
#define QUEUE 259
#define COMPRESSION 260
#define ENCRYPTION 261
#define MAXMESSAGESIZE 262
#define MAXMTADEFERRED 263
#define LISTEN 264
#define ON 265
#define ANY 266
#define PORT 267
#define EXPIRE 268
#define TABLE 269
#define SECURE 270
#define SMTPS 271
#define CERTIFICATE 272
#define DOMAIN 273
#define BOUNCEWARN 274
#define LIMIT 275
#define INET4 276
#define INET6 277
#define NODSN 278
#define SESSION 279
#define RELAY 280
#define BACKUP 281
#define VIA 282
#define DELIVER 283
#define TO 284
#define LMTP 285
#define MAILDIR 286
#define MBOX 287
#define HOSTNAME 288
#define HOSTNAMES 289
#define ACCEPT 290
#define REJECT 291
#define INCLUDE 292
#define ERROR 293
#define MDA 294
#define FROM 295
#define FOR 296
#define SOURCE 297
#define MTA 298
#define PKI 299
#define SCHEDULER 300
#define ARROW 301
#define AUTH 302
#define TLS 303
#define LOCAL 304
#define VIRTUAL 305
#define TAG 306
#define TAGGED 307
#define ALIAS 308
#define FILTER 309
#define KEY 310
#define CA 311
#define DHPARAMS 312
#define AUTH_OPTIONAL 313
#define TLS_REQUIRE 314
#define USERBASE 315
#define SENDER 316
#define SENDERS 317
#define MASK_SOURCE 318
#define VERIFY 319
#define FORWARDONLY 320
#define RECIPIENT 321
#define CIPHERS 322
#define CURVE 323
#define RECEIVEDAUTH 324
#define MASQUERADE 325
#define DSNNOTIFY 326
#define DISABLE 327
#define DSNRET 328
#define HEADERS 329
#define ENQUEUER 330
#define STRING 331
#define NUMBER 332

/* Value type.  */


extern YYSTYPE yylval;

int yyparse (void);



/* Copy the second part of user declarations.  */

#line 419 "../../smtpd/parse.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  2
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   243

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  86
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  77
/* YYNRULES -- Number of rules.  */
#define YYNRULES  189
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  295

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   332

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      78,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    85,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,    80,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      83,    79,    84,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    81,     2,    82,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   195,   195,   196,   197,   198,   199,   200,   201,   202,
     205,   220,   228,   229,   230,   233,   234,   237,   240,   247,
     260,   272,   291,   292,   293,   296,   321,   322,   325,   341,
     342,   345,   348,   351,   361,   362,   365,   387,   388,   391,
     396,   399,   402,   405,   410,   411,   414,   422,   430,   448,
     461,   469,   477,   485,   493,   501,   509,   517,   525,   533,
     541,   549,   558,   567,   581,   590,   606,   614,   622,   630,
     642,   654,   670,   688,   689,   692,   717,   727,   732,   742,
     757,   774,   785,   791,   794,   799,   800,   801,   804,   815,
     824,   825,   826,   829,   829,   832,   835,   838,   847,   856,
     859,   862,   863,   864,   864,   876,   876,   879,   880,   880,
     889,   903,   903,   919,   919,   939,   939,   959,   962,   967,
     968,   968,   976,  1013,  1013,  1021,  1021,  1023,  1031,  1032,
    1035,  1042,  1043,  1046,  1047,  1050,  1059,  1059,  1066,  1079,
    1080,  1083,  1096,  1108,  1116,  1126,  1142,  1148,  1151,  1158,
    1166,  1173,  1184,  1194,  1197,  1197,  1216,  1217,  1220,  1235,
    1243,  1253,  1268,  1276,  1286,  1304,  1322,  1331,  1346,  1347,
    1348,  1349,  1350,  1352,  1353,  1356,  1357,  1359,  1360,  1363,
    1364,  1365,  1368,  1369,  1372,  1373,  1376,  1376,  1408,  1408
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "AS", "QUEUE", "COMPRESSION",
  "ENCRYPTION", "MAXMESSAGESIZE", "MAXMTADEFERRED", "LISTEN", "ON", "ANY",
  "PORT", "EXPIRE", "TABLE", "SECURE", "SMTPS", "CERTIFICATE", "DOMAIN",
  "BOUNCEWARN", "LIMIT", "INET4", "INET6", "NODSN", "SESSION", "RELAY",
  "BACKUP", "VIA", "DELIVER", "TO", "LMTP", "MAILDIR", "MBOX", "HOSTNAME",
  "HOSTNAMES", "ACCEPT", "REJECT", "INCLUDE", "ERROR", "MDA", "FROM",
  "FOR", "SOURCE", "MTA", "PKI", "SCHEDULER", "ARROW", "AUTH", "TLS",
  "LOCAL", "VIRTUAL", "TAG", "TAGGED", "ALIAS", "FILTER", "KEY", "CA",
  "DHPARAMS", "AUTH_OPTIONAL", "TLS_REQUIRE", "USERBASE", "SENDER",
  "SENDERS", "MASK_SOURCE", "VERIFY", "FORWARDONLY", "RECIPIENT",
  "CIPHERS", "CURVE", "RECEIVEDAUTH", "MASQUERADE", "DSNNOTIFY", "DISABLE",
  "DSNRET", "HEADERS", "ENQUEUER", "STRING", "NUMBER", "'\\n'", "'='",
  "','", "'{'", "'}'", "'<'", "'>'", "'!'", "$accept", "grammar",
  "include", "varset", "comma", "optnl", "nl", "size", "tagged",
  "bouncedelay", "bouncedelays", "opt_limit_mda", "limits_session",
  "opt_limit_session", "limits_mda", "opt_limit_mta", "limits_mta",
  "opt_limit_scheduler", "limits_scheduler", "opt_ca", "ca", "opt_pki",
  "pki", "opt_listen", "listen", "opt_relay_common", "opt_relay", "relay",
  "opt_relay_via", "relay_via", "main", "$@1", "$@2", "$@3", "$@4", "$@5",
  "$@6", "$@7", "filter_args", "$@8", "table", "$@9", "assign", "keyval",
  "keyval_list", "stringel", "string_list", "tableval_list", "tablenew",
  "$@10", "tableref", "tables", "alias", "virtual", "usermapping",
  "userbase", "deliver_as", "deliver_action", "relay_action", "$@11",
  "negation", "from", "for", "sender", "recipient", "forwardonly",
  "expire", "opt_decision", "decision", "opt_lookup", "lookup", "action",
  "opt_accept", "accept_params", "rule", "$@12", "$@13", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    10,    61,
      44,   123,   125,    60,    62,    33
};
# endif

#define YYPACT_NINF -191

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-191)))

#define YYTABLE_NINF -132

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    -191,     6,  -191,   -67,    87,    67,   -44,  -191,   -36,   -30,
    -191,   103,  -191,  -191,   -20,   -13,    -9,    -4,    12,    22,
      53,    34,  -191,    54,    57,    59,    69,    82,  -191,  -191,
      60,  -191,  -191,  -191,  -191,   151,  -191,    86,    88,    89,
      90,   122,    91,    68,    68,  -191,  -191,    93,  -191,  -191,
    -191,    94,    95,  -191,  -191,  -191,  -191,  -191,    96,    98,
    -191,    92,  -191,  -191,    99,   100,  -191,    89,   101,    90,
    -191,   157,    -5,   104,    91,  -191,   102,   102,   102,   102,
     102,  -191,  -191,  -191,  -191,  -191,    68,   -32,  -191,    13,
    -191,   159,  -191,  -191,  -191,    43,   106,    88,  -191,  -191,
    -191,  -191,   107,  -191,  -191,   108,    -5,  -191,  -191,  -191,
    -191,    37,    26,   110,     2,     2,  -191,     2,     2,     2,
    -191,  -191,  -191,  -191,   -32,     7,   112,   113,   114,    13,
    -191,   115,   116,  -191,  -191,    78,  -191,   120,  -191,  -191,
    -191,   117,     2,   118,     2,  -191,   119,   121,   123,     2,
     132,     2,  -191,  -191,   126,   127,    43,  -191,   -34,    46,
    -191,    58,  -191,   124,  -191,  -191,  -191,  -191,  -191,     2,
    -191,  -191,     2,  -191,  -191,  -191,  -191,   128,  -191,  -191,
    -191,  -191,  -191,  -191,  -191,  -191,    77,   171,  -191,  -191,
     -12,  -191,  -191,  -191,  -191,  -191,  -191,  -191,  -191,  -191,
    -191,  -191,  -191,  -191,  -191,  -191,  -191,  -191,  -191,  -191,
     133,  -191,  -191,  -191,  -191,  -191,   129,   130,  -191,   131,
    -191,   134,  -191,    -5,  -191,  -191,   106,   125,   135,   136,
     137,   138,     2,     2,   139,   152,   141,    97,    97,  -191,
      -8,   142,  -191,  -191,  -191,   -12,  -191,   115,  -191,  -191,
     130,  -191,   -34,  -191,  -191,  -191,  -191,   140,  -191,  -191,
    -191,  -191,  -191,  -191,  -191,  -191,  -191,  -191,  -191,  -191,
     143,   144,  -191,   145,  -191,  -191,  -191,  -191,  -191,     5,
     177,  -191,   177,     2,  -191,     5,     5,  -191,   147,  -191,
    -191,  -191,  -191,  -191,  -191
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       2,     0,     1,     0,     0,     0,     0,   108,     0,     0,
      93,     0,   186,   188,     0,     0,     0,     0,     0,     0,
       0,     0,     3,     0,     0,     0,     0,     0,     9,    95,
      96,    19,    18,    99,   100,     0,    98,   123,    24,    27,
      30,   105,    38,   174,   174,    10,   113,     0,   115,   117,
     118,     0,     0,     4,     5,     6,     7,     8,     0,     0,
     122,     0,    21,    23,    94,     0,   101,    27,     0,    30,
     102,     0,    35,     0,    38,   107,   157,   157,   157,   157,
     157,   172,   170,   171,   168,   169,   174,   178,   189,    45,
     111,     0,   110,    11,    97,    74,     0,     0,    28,    26,
      25,    29,     0,    31,    32,     0,    35,   106,    36,    37,
     156,     0,     0,     0,     0,     0,   173,     0,     0,     0,
     143,   144,   176,   175,   178,   181,     0,     0,     0,    45,
     114,   119,     0,    40,   116,     0,    54,    51,    46,    47,
      68,     0,     0,     0,    59,    53,     0,     0,     0,    60,
      55,     0,    66,    67,     0,     0,    74,   109,   130,    14,
     134,    14,   133,     0,    22,   103,    33,    34,   159,     0,
     160,   162,     0,   163,    20,   135,   136,     0,   139,   140,
     164,   165,   142,   141,   145,   177,    87,     0,   179,   180,
     185,    41,    42,    43,    44,   120,   112,    39,    48,    49,
      52,    64,    65,    57,    61,    63,    50,    58,    62,    56,
      71,    69,    70,    73,   126,   125,     0,    16,    12,     0,
      13,     0,   124,    35,   158,   161,     0,     0,     0,    82,
       0,     0,     0,     0,     0,    83,     0,    87,    87,   153,
       0,     0,   166,   183,   182,   185,   187,   119,    72,   127,
      16,    17,     0,   129,   130,   132,   104,     0,   138,    75,
      81,   154,    77,    78,    76,    79,    84,    80,    85,    86,
       0,   148,   150,     0,   167,   184,   121,    15,   137,    92,
     147,   149,   147,     0,    89,    92,    92,   155,     0,   151,
     152,    88,    90,    91,   146
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -191,  -191,  -191,  -191,    41,   -26,  -191,  -191,  -191,   146,
    -191,  -191,   158,  -191,   160,  -191,  -101,  -191,   153,  -191,
    -191,  -191,   105,  -191,    70,  -190,  -191,   -81,  -191,  -127,
    -191,  -191,  -191,  -191,  -191,  -191,  -191,  -191,   -19,  -191,
    -191,  -191,  -191,  -191,    11,  -191,    10,     9,  -191,  -191,
    -191,  -115,  -191,  -191,  -191,  -191,   -50,  -191,  -191,  -191,
      72,  -191,  -191,  -191,  -191,  -191,  -191,  -191,   -35,  -191,
     109,  -191,  -191,    -7,  -191,  -191,  -191
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     1,    23,    24,   219,   251,   220,    33,    81,    63,
      64,    69,    66,    67,    70,   106,   107,    74,    75,   133,
     134,   129,   130,   156,   157,   237,   238,   239,   286,   287,
      25,    38,   223,    72,    35,   131,    89,    91,   196,   247,
      26,    61,   216,   159,   160,   161,   162,   163,   178,   226,
     179,   180,   120,   121,   122,   123,   289,   188,   189,   279,
     111,    82,    83,    84,    85,   243,   244,    86,    87,   124,
     125,   190,   245,   246,    27,    43,    44
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     181,   241,   182,   183,   184,   167,     2,     3,   228,    88,
       4,    28,   214,     5,     6,     7,   103,   104,   117,     8,
       9,   118,   270,   271,   272,    10,    11,   202,   119,   204,
     126,   273,   186,    34,   208,   187,   210,   171,   231,   232,
      36,    12,    13,    14,   172,   215,    37,   233,   168,   234,
      15,   116,   283,   242,   224,   135,    45,   225,   136,   137,
      16,   236,    17,    46,   138,   139,   140,    47,   127,   284,
     128,   105,    48,    18,    19,   173,   141,   142,   175,   169,
     228,    20,    21,   176,    22,   177,   170,   143,    49,   285,
     144,   145,    29,    30,   146,   285,   285,   147,    50,   148,
     228,   149,   150,   229,   230,   151,   152,    51,    76,    77,
     231,   232,   153,    52,   154,    58,   155,   263,   264,   233,
      78,   234,   256,   229,   217,   235,   218,    39,  -128,    79,
     231,   232,    53,   236,    80,    54,   217,    55,   218,   233,
    -131,   234,    40,    31,    32,   235,    41,    56,    42,   112,
     113,   114,   115,   236,   198,   199,   268,   269,   292,   293,
      57,    59,    60,    71,    62,    65,    68,    73,   291,    90,
      92,    93,    94,    96,    95,   102,   132,    98,   100,    97,
     288,   108,   158,   165,   200,   166,   174,   110,   191,   192,
     193,   195,   197,   201,   203,   205,   209,   206,   211,   207,
     240,   212,   221,   248,   227,   249,   222,   252,   250,   258,
     254,   259,   260,   261,   262,   265,   266,   267,   274,   280,
     281,   282,   278,   294,   277,    99,   213,   109,   276,   101,
     253,   255,   290,   185,   194,   257,     0,     0,   275,     0,
       0,     0,     0,   164
};

static const yytype_int16 yycheck[] =
{
     115,    13,   117,   118,   119,   106,     0,     1,     3,    44,
       4,    78,    46,     7,     8,     9,    21,    22,    50,    13,
      14,    53,    30,    31,    32,    19,    20,   142,    60,   144,
      17,    39,    25,    77,   149,    28,   151,    11,    33,    34,
      76,    35,    36,    37,    18,    79,    76,    42,    11,    44,
      44,    86,    47,    65,   169,    12,    76,   172,    15,    16,
      54,    56,    56,    76,    21,    22,    23,    76,    55,    64,
      57,    76,    76,    67,    68,    49,    33,    34,    76,    42,
       3,    75,    76,    81,    78,    83,    49,    44,    76,   279,
      47,    48,     5,     6,    51,   285,   286,    54,    76,    56,
       3,    58,    59,    26,    27,    62,    63,    54,    40,    41,
      33,    34,    69,    79,    71,    55,    73,   232,   233,    42,
      52,    44,   223,    26,    78,    48,    80,    24,    82,    61,
      33,    34,    78,    56,    66,    78,    78,    78,    80,    42,
      82,    44,    39,    76,    77,    48,    43,    78,    45,    77,
      78,    79,    80,    56,    76,    77,   237,   238,   285,   286,
      78,    10,    76,    41,    76,    76,    76,    76,   283,    76,
      76,    76,    76,    81,    76,    18,    17,    77,    77,    80,
       3,    77,    76,    76,    64,    77,    76,    85,    76,    76,
      76,    76,    76,    76,    76,    76,    64,    76,    72,    76,
      29,    74,   161,    70,    76,    76,    82,    76,    78,    84,
      76,    76,    76,    76,    76,    76,    64,    76,    76,    76,
      76,    76,    82,    76,   250,    67,   156,    74,   247,    69,
     219,   221,   282,   124,   129,   226,    -1,    -1,   245,    -1,
      -1,    -1,    -1,    97
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    87,     0,     1,     4,     7,     8,     9,    13,    14,
      19,    20,    35,    36,    37,    44,    54,    56,    67,    68,
      75,    76,    78,    88,    89,   116,   126,   160,    78,     5,
       6,    76,    77,    93,    77,   120,    76,    76,   117,    24,
      39,    43,    45,   161,   162,    76,    76,    76,    76,    76,
      76,    54,    79,    78,    78,    78,    78,    78,    55,    10,
      76,   127,    76,    95,    96,    76,    98,    99,    76,    97,
     100,    41,   119,    76,   103,   104,    40,    41,    52,    61,
      66,    94,   147,   148,   149,   150,   153,   154,   154,   122,
      76,   123,    76,    76,    76,    76,    81,    80,    77,    98,
      77,   100,    18,    21,    22,    76,   101,   102,    77,   104,
      85,   146,   146,   146,   146,   146,   154,    50,    53,    60,
     138,   139,   140,   141,   155,   156,    17,    55,    57,   107,
     108,   121,    17,   105,   106,    12,    15,    16,    21,    22,
      23,    33,    34,    44,    47,    48,    51,    54,    56,    58,
      59,    62,    63,    69,    71,    73,   109,   110,    76,   129,
     130,   131,   132,   133,    95,    76,    77,   102,    11,    42,
      49,    11,    18,    49,    76,    76,    81,    83,   134,   136,
     137,   137,   137,   137,   137,   156,    25,    28,   143,   144,
     157,    76,    76,    76,   108,    76,   124,    76,    76,    77,
      64,    76,   137,    76,   137,    76,    76,    76,   137,    64,
     137,    72,    74,   110,    46,    79,   128,    78,    80,    90,
      92,    90,    82,   118,   137,   137,   135,    76,     3,    26,
      27,    33,    34,    42,    44,    48,    56,   111,   112,   113,
      29,    13,    65,   151,   152,   158,   159,   125,    70,    76,
      78,    91,    76,   130,    76,   132,   102,   133,    84,    76,
      76,    76,    76,   137,   137,    76,    64,    76,   113,   113,
      30,    31,    32,    39,    76,   159,   124,    91,    82,   145,
      76,    76,    76,    47,    64,   111,   114,   115,     3,   142,
     142,   137,   115,   115,    76
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    86,    87,    87,    87,    87,    87,    87,    87,    87,
      88,    89,    90,    90,    90,    91,    91,    92,    93,    93,
      94,    95,    96,    96,    96,    97,    98,    98,    99,   100,
     100,   101,   101,   101,   102,   102,   103,   104,   104,   105,
     106,   107,   107,   107,   108,   108,   109,   109,   109,   109,
     109,   109,   109,   109,   109,   109,   109,   109,   109,   109,
     109,   109,   109,   109,   109,   109,   109,   109,   109,   109,
     109,   109,   109,   110,   110,   111,   111,   111,   111,   111,
     111,   112,   112,   112,   112,   113,   113,   113,   114,   114,
     115,   115,   115,   117,   116,   116,   116,   116,   116,   116,
     116,   116,   116,   118,   116,   119,   116,   116,   120,   116,
     116,   121,   116,   122,   116,   123,   116,   116,   116,   124,
     125,   124,   126,   127,   126,   128,   128,   129,   130,   130,
     131,   132,   132,   133,   133,   134,   135,   134,   136,   137,
     137,   138,   139,   140,   140,   141,   142,   142,   143,   143,
     143,   143,   143,   144,   145,   144,   146,   146,   147,   147,
     147,   148,   148,   148,   149,   150,   151,   152,   153,   153,
     153,   153,   153,   154,   154,   155,   155,   156,   156,   157,
     157,   157,   158,   158,   159,   159,   161,   160,   162,   160
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     0,     2,     3,     3,     3,     3,     3,     3,
       2,     3,     1,     1,     0,     2,     0,     2,     1,     1,
       3,     1,     3,     1,     0,     2,     2,     0,     2,     2,
       0,     1,     1,     2,     2,     0,     2,     2,     0,     2,
       1,     2,     2,     2,     2,     0,     1,     1,     2,     2,
       2,     1,     2,     1,     1,     1,     2,     2,     2,     1,
       1,     2,     2,     2,     2,     2,     1,     1,     1,     2,
       2,     2,     3,     2,     0,     2,     2,     2,     2,     2,
       2,     2,     1,     1,     2,     2,     2,     0,     2,     1,
       2,     2,     0,     0,     3,     2,     2,     4,     2,     2,
       2,     3,     3,     0,     7,     0,     4,     3,     0,     5,
       3,     0,     5,     0,     4,     0,     4,     2,     2,     0,
       0,     3,     3,     0,     6,     1,     1,     3,     1,     3,
       1,     1,     3,     1,     1,     1,     0,     4,     3,     1,
       1,     2,     2,     1,     1,     2,     2,     0,     3,     4,
       3,     5,     5,     2,     0,     5,     1,     0,     4,     3,
       3,     4,     3,     3,     3,     3,     1,     2,     1,     1,
       1,     1,     1,     2,     0,     1,     1,     2,     0,     1,
       1,     0,     1,     1,     2,     0,     0,     6,     0,     3
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 9:
#line 202 "../../smtpd/parse.y" /* yacc.c:1646  */
    { file->errors++; }
#line 1727 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 10:
#line 205 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			struct file	*nfile;

			if ((nfile = pushfile((yyvsp[0].v.string), 0)) == NULL) {
				yyerror("failed to include file %s", (yyvsp[0].v.string));
				free((yyvsp[0].v.string));
				YYERROR;
			}
			free((yyvsp[0].v.string));

			file = nfile;
			lungetc('\n');
		}
#line 1745 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 11:
#line 220 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			if (symset((yyvsp[-2].v.string), (yyvsp[0].v.string), 0) == -1)
				fatal("cannot store variable");
			free((yyvsp[-2].v.string));
			free((yyvsp[0].v.string));
		}
#line 1756 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 18:
#line 240 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			if ((yyvsp[0].v.number) < 0) {
				yyerror("invalid size: %" PRId64, (yyvsp[0].v.number));
				YYERROR;
			}
			(yyval.v.number) = (yyvsp[0].v.number);
		}
#line 1768 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 19:
#line 247 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			long long result;

			if (scan_scaled((yyvsp[0].v.string), &result) == -1 || result < 0) {
				yyerror("invalid size: %s", (yyvsp[0].v.string));
				free((yyvsp[0].v.string));
				YYERROR;
			}
			free((yyvsp[0].v.string));
			(yyval.v.number) = result;
		}
#line 1784 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 20:
#line 260 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			if (strlcpy(rule->r_tag, (yyvsp[0].v.string), sizeof rule->r_tag)
			    >= sizeof rule->r_tag) {
				yyerror("tag name too long: %s", (yyvsp[0].v.string));
				free((yyvsp[0].v.string));
				YYERROR;
			}
			free((yyvsp[0].v.string));
			rule->r_nottag = (yyvsp[-1].v.number);
		}
#line 1799 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 21:
#line 272 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			time_t	d;
			int	i;

			d = delaytonum((yyvsp[0].v.string));
			if (d < 0) {
				yyerror("invalid bounce delay: %s", (yyvsp[0].v.string));
				free((yyvsp[0].v.string));
				YYERROR;
			}
			free((yyvsp[0].v.string));
			for (i = 0; i < MAX_BOUNCE_WARN; i++) {
				if (conf->sc_bounce_warn[i] != 0)
					continue;
				conf->sc_bounce_warn[i] = d;
				break;
			}
		}
#line 1822 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 25:
#line 296 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			if (!strcmp((yyvsp[-1].v.string), "max-session")) {
				conf->sc_mda_max_session = (yyvsp[0].v.number);
			}
			else if (!strcmp((yyvsp[-1].v.string), "max-session-per-user")) {
				conf->sc_mda_max_user_session = (yyvsp[0].v.number);
			}
			else if (!strcmp((yyvsp[-1].v.string), "task-lowat")) {
				conf->sc_mda_task_lowat = (yyvsp[0].v.number);
			}
			else if (!strcmp((yyvsp[-1].v.string), "task-hiwat")) {
				conf->sc_mda_task_hiwat = (yyvsp[0].v.number);
			}
			else if (!strcmp((yyvsp[-1].v.string), "task-release")) {
				conf->sc_mda_task_release = (yyvsp[0].v.number);
			}
			else {
				yyerror("invalid scheduler limit keyword: %s", (yyvsp[-1].v.string));
				free((yyvsp[-1].v.string));
				YYERROR;
			}
			free((yyvsp[-1].v.string));
		}
#line 1850 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 28:
#line 325 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			if (!strcmp((yyvsp[-1].v.string), "max-rcpt")) {
				conf->sc_session_max_rcpt = (yyvsp[0].v.number);
			}
			else if (!strcmp((yyvsp[-1].v.string), "max-mails")) {
				conf->sc_session_max_mails = (yyvsp[0].v.number);
			}
			else {
				yyerror("invalid session limit keyword: %s", (yyvsp[-1].v.string));
				free((yyvsp[-1].v.string));
				YYERROR;
			}
			free((yyvsp[-1].v.string));
		}
#line 1869 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 31:
#line 345 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			limits->family = AF_INET;
		}
#line 1877 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 32:
#line 348 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			limits->family = AF_INET6;
		}
#line 1885 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 33:
#line 351 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			if (!limit_mta_set(limits, (yyvsp[-1].v.string), (yyvsp[0].v.number))) {
				yyerror("invalid mta limit keyword: %s", (yyvsp[-1].v.string));
				free((yyvsp[-1].v.string));
				YYERROR;
			}
			free((yyvsp[-1].v.string));
		}
#line 1898 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 36:
#line 365 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			if (!strcmp((yyvsp[-1].v.string), "max-inflight")) {
				conf->sc_scheduler_max_inflight = (yyvsp[0].v.number);
			}
			else if (!strcmp((yyvsp[-1].v.string), "max-evp-batch-size")) {
				conf->sc_scheduler_max_evp_batch_size = (yyvsp[0].v.number);
			}
			else if (!strcmp((yyvsp[-1].v.string), "max-msg-batch-size")) {
				conf->sc_scheduler_max_msg_batch_size = (yyvsp[0].v.number);
			}
			else if (!strcmp((yyvsp[-1].v.string), "max-schedule")) {
				conf->sc_scheduler_max_schedule = (yyvsp[0].v.number);
			}
			else {
				yyerror("invalid scheduler limit keyword: %s", (yyvsp[-1].v.string));
				free((yyvsp[-1].v.string));
				YYERROR;
			}
			free((yyvsp[-1].v.string));
		}
#line 1923 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 39:
#line 391 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			sca->ca_cert_file = (yyvsp[0].v.string);
		}
#line 1931 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 41:
#line 399 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			pki->pki_cert_file = (yyvsp[0].v.string);
		}
#line 1939 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 42:
#line 402 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			pki->pki_key_file = (yyvsp[0].v.string);
		}
#line 1947 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 43:
#line 405 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			pki->pki_dhparams_file = (yyvsp[0].v.string);
		}
#line 1955 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 46:
#line 414 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			if (listen_opts.options & LO_FAMILY) {
				yyerror("address family already specified");
				YYERROR;	
			}
			listen_opts.options |= LO_FAMILY;
			listen_opts.family = AF_INET;
		}
#line 1968 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 47:
#line 422 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			if (listen_opts.options & LO_FAMILY) {
				yyerror("address family already specified");
				YYERROR;	
			}
			listen_opts.options |= LO_FAMILY;
			listen_opts.family = AF_INET6;
		}
#line 1981 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 48:
#line 430 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			struct servent	*servent;

			if (listen_opts.options & LO_PORT) {
				yyerror("port already specified");
				YYERROR;	
			}
			listen_opts.options |= LO_PORT;

			servent = getservbyname((yyvsp[0].v.string), "tcp");
			if (servent == NULL) {
				yyerror("invalid port: %s", (yyvsp[0].v.string));
				free((yyvsp[0].v.string));
				YYERROR;
			}
			free((yyvsp[0].v.string));
			listen_opts.port = ntohs(servent->s_port);
		}
#line 2004 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 49:
#line 448 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			if (listen_opts.options & LO_PORT) {
				yyerror("port already specified");
				YYERROR;	
			}
			listen_opts.options |= LO_PORT;

			if ((yyvsp[0].v.number) <= 0 || (yyvsp[0].v.number) >= (int)USHRT_MAX) {
				yyerror("invalid port: %" PRId64, (yyvsp[0].v.number));
				YYERROR;
			}
			listen_opts.port = (yyvsp[0].v.number);
		}
#line 2022 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 50:
#line 461 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			if (listen_opts.options & LO_FILTER) {
				yyerror("filter already specified");
				YYERROR;	
			}
			listen_opts.options |= LO_FILTER;
			listen_opts.filtername = (yyvsp[0].v.string);
		}
#line 2035 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 51:
#line 469 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			if (listen_opts.options & LO_SSL) {
				yyerror("TLS mode already specified");
				YYERROR;	
			}
			listen_opts.options |= LO_SSL;
			listen_opts.ssl = F_SMTPS;
		}
#line 2048 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 52:
#line 477 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			if (listen_opts.options & LO_SSL) {
				yyerror("TLS mode already specified");
				YYERROR;	
			}
			listen_opts.options |= LO_SSL;
			listen_opts.ssl = F_SMTPS|F_TLS_VERIFY;
		}
#line 2061 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 53:
#line 485 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			if (listen_opts.options & LO_SSL) {
				yyerror("TLS mode already specified");
				YYERROR;	
			}
			listen_opts.options |= LO_SSL;
			listen_opts.ssl = F_STARTTLS;
		}
#line 2074 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 54:
#line 493 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			if (listen_opts.options & LO_SSL) {
				yyerror("TLS mode already specified");
				YYERROR;	
			}
			listen_opts.options |= LO_SSL;
			listen_opts.ssl = F_SSL;
		}
#line 2087 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 55:
#line 501 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			if (listen_opts.options & LO_SSL) {
				yyerror("TLS mode already specified");
				YYERROR;	
			}
			listen_opts.options |= LO_SSL;
			listen_opts.ssl = F_STARTTLS|F_STARTTLS_REQUIRE;
		}
#line 2100 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 56:
#line 509 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			if (listen_opts.options & LO_SSL) {
				yyerror("TLS mode already specified");
				YYERROR;	
			}
			listen_opts.options |= LO_SSL;
			listen_opts.ssl = F_STARTTLS|F_STARTTLS_REQUIRE|F_TLS_VERIFY;
		}
#line 2113 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 57:
#line 517 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			if (listen_opts.options & LO_PKI) {
				yyerror("pki already specified");
				YYERROR;	
			}
			listen_opts.options |= LO_PKI;
			listen_opts.pki = (yyvsp[0].v.string);
		}
#line 2126 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 58:
#line 525 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			if (listen_opts.options & LO_CA) {
				yyerror("ca already specified");
				YYERROR;
			}
			listen_opts.options |= LO_CA;
			listen_opts.ca = (yyvsp[0].v.string);
		}
#line 2139 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 59:
#line 533 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			if (listen_opts.options & LO_AUTH) {
				yyerror("auth already specified");
				YYERROR;	
			}
			listen_opts.options |= LO_AUTH;
			listen_opts.auth = F_AUTH|F_AUTH_REQUIRE;
		}
#line 2152 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 60:
#line 541 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			if (listen_opts.options & LO_AUTH) {
				yyerror("auth already specified");
				YYERROR;	
			}
			listen_opts.options |= LO_AUTH;
			listen_opts.auth = F_AUTH;
		}
#line 2165 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 61:
#line 549 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			if (listen_opts.options & LO_AUTH) {
				yyerror("auth already specified");
				YYERROR;	
			}
			listen_opts.options |= LO_AUTH;
			listen_opts.authtable = (yyvsp[0].v.table);
			listen_opts.auth = F_AUTH|F_AUTH_REQUIRE;
		}
#line 2179 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 62:
#line 558 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			if (listen_opts.options & LO_AUTH) {
				yyerror("auth already specified");
				YYERROR;	
			}
			listen_opts.options |= LO_AUTH;
			listen_opts.authtable = (yyvsp[0].v.table);
			listen_opts.auth = F_AUTH;
		}
#line 2193 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 63:
#line 567 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			if (listen_opts.options & LO_TAG) {
				yyerror("tag already specified");
				YYERROR;	
			}
			listen_opts.options |= LO_TAG;

       			if (strlen((yyvsp[0].v.string)) >= SMTPD_TAG_SIZE) {
       				yyerror("tag name too long");
				free((yyvsp[0].v.string));
				YYERROR;
			}
			listen_opts.tag = (yyvsp[0].v.string);
		}
#line 2212 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 64:
#line 581 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			if (listen_opts.options & LO_HOSTNAME) {
				yyerror("hostname already specified");
				YYERROR;	
			}
			listen_opts.options |= LO_HOSTNAME;

			listen_opts.hostname = (yyvsp[0].v.string);
		}
#line 2226 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 65:
#line 590 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			struct table	*t = (yyvsp[0].v.table);

			if (listen_opts.options & LO_HOSTNAMES) {
				yyerror("hostnames already specified");
				YYERROR;	
			}
			listen_opts.options |= LO_HOSTNAMES;

			if (! table_check_use(t, T_DYNAMIC|T_HASH, K_ADDRNAME)) {
				yyerror("invalid use of table \"%s\" as "
				    "HOSTNAMES parameter", t->t_name);
				YYERROR;
			}
			listen_opts.hostnametable = t;
		}
#line 2247 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 66:
#line 606 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			if (listen_opts.options & LO_MASKSOURCE) {
				yyerror("mask-source already specified");
				YYERROR;	
			}
			listen_opts.options |= LO_MASKSOURCE;
			listen_opts.flags |= F_MASK_SOURCE;
		}
#line 2260 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 67:
#line 614 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			if (listen_opts.options & LO_RECEIVEDAUTH) {
				yyerror("received-auth already specified");
				YYERROR;	
			}
			listen_opts.options |= LO_RECEIVEDAUTH;
			listen_opts.flags |= F_RECEIVEDAUTH;
		}
#line 2273 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 68:
#line 622 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			if (listen_opts.options & LO_NODSN) {
				yyerror("no-dsn already specified");
				YYERROR;	
			}
			listen_opts.options |= LO_NODSN;
			listen_opts.flags &= ~F_EXT_DSN;
		}
#line 2286 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 69:
#line 630 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			if (listen_opts.options & LO_DSNRET_HEADERS) {
				yyerror("dsn-notify used in ambiguous context");
				YYERROR;
			}
			if (listen_opts.options & LO_DSNNOTIFY_DISABLE) {
				yyerror("dsn-notify already specified");
				YYERROR;
			}
			listen_opts.options |= LO_DSNNOTIFY_DISABLE;
			listen_opts.flags |= F_DSNNOTIFY_DISABLE;
		}
#line 2303 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 70:
#line 642 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			if (listen_opts.options & LO_DSNNOTIFY_DISABLE) {
				yyerror("dsn-ret used in ambiguous context");
				YYERROR;
			}
			if (listen_opts.options & LO_DSNRET_HEADERS) {
				yyerror("dsn-ret already specified");
				YYERROR;
			}
			listen_opts.options |= LO_DSNRET_HEADERS;
			listen_opts.flags |= F_DSNRET_HEADERS;
		}
#line 2320 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 71:
#line 654 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			struct table	*t = (yyvsp[0].v.table);

			if (listen_opts.options & LO_SENDERS) {
				yyerror("senders already specified");
				YYERROR;
			}
			listen_opts.options |= LO_SENDERS;

			if (! table_check_use(t, T_DYNAMIC|T_HASH, K_MAILADDRMAP)) {
				yyerror("invalid use of table \"%s\" as "
				    "SENDERS parameter", t->t_name);
				YYERROR;
			}
			listen_opts.sendertable = t;
		}
#line 2341 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 72:
#line 670 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			struct table	*t = (yyvsp[-1].v.table);

			if (listen_opts.options & LO_SENDERS) {
				yyerror("senders already specified");
				YYERROR;
			}
			listen_opts.options |= LO_SENDERS|LO_MASQUERADE;

			if (! table_check_use(t, T_DYNAMIC|T_HASH, K_MAILADDRMAP)) {
				yyerror("invalid use of table \"%s\" as "
				    "SENDERS parameter", t->t_name);
				YYERROR;
			}
			listen_opts.sendertable = t;
		}
#line 2362 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 75:
#line 692 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			struct mailaddr maddr, *maddrp;

			if (! text_to_mailaddr(&maddr, (yyvsp[0].v.string))) {
				yyerror("invalid parameter to AS: %s", (yyvsp[0].v.string));
				free((yyvsp[0].v.string));
				YYERROR;
			}
			free((yyvsp[0].v.string));

			if (maddr.user[0] == '\0' && maddr.domain[0] == '\0') {
				yyerror("invalid empty parameter to AS");
				YYERROR;
			}
			else if (maddr.domain[0] == '\0') {
				if (strlcpy(maddr.domain, conf->sc_hostname,
					sizeof (maddr.domain))
				    >= sizeof (maddr.domain)) {
					yyerror("hostname too long for AS parameter: %s",
					    conf->sc_hostname);
					YYERROR;
				}
			}
			rule->r_as = xmemdup(&maddr, sizeof (*maddrp), "parse relay_as: AS");
		}
#line 2392 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 76:
#line 717 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			struct table	*t = (yyvsp[0].v.table);
			if (! table_check_use(t, T_DYNAMIC|T_LIST, K_SOURCE)) {
				yyerror("invalid use of table \"%s\" as "
				    "SOURCE parameter", t->t_name);
				YYERROR;
			}
			(void)strlcpy(rule->r_value.relayhost.sourcetable, t->t_name,
			    sizeof rule->r_value.relayhost.sourcetable);
		}
#line 2407 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 77:
#line 727 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			(void)strlcpy(rule->r_value.relayhost.heloname, (yyvsp[0].v.string),
			    sizeof rule->r_value.relayhost.heloname);
			free((yyvsp[0].v.string));
		}
#line 2417 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 78:
#line 732 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			struct table	*t = (yyvsp[0].v.table);
			if (! table_check_use(t, T_DYNAMIC|T_HASH, K_ADDRNAME)) {
				yyerror("invalid use of table \"%s\" as "
				    "HOSTNAMES parameter", t->t_name);
				YYERROR;
			}
			(void)strlcpy(rule->r_value.relayhost.helotable, t->t_name,
			    sizeof rule->r_value.relayhost.helotable);
		}
#line 2432 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 79:
#line 742 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			if (! lowercase(rule->r_value.relayhost.pki_name, (yyvsp[0].v.string),
				sizeof(rule->r_value.relayhost.pki_name))) {
				yyerror("pki name too long: %s", (yyvsp[0].v.string));
				free((yyvsp[0].v.string));
				YYERROR;
			}
			if (dict_get(conf->sc_pki_dict,
			    rule->r_value.relayhost.pki_name) == NULL) {
				log_warnx("pki name not found: %s", (yyvsp[0].v.string));
				free((yyvsp[0].v.string));
				YYERROR;
			}
			free((yyvsp[0].v.string));
		}
#line 2452 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 80:
#line 757 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			if (! lowercase(rule->r_value.relayhost.ca_name, (yyvsp[0].v.string),
				sizeof(rule->r_value.relayhost.ca_name))) {
				yyerror("ca name too long: %s", (yyvsp[0].v.string));
				free((yyvsp[0].v.string));
				YYERROR;
			}
			if (dict_get(conf->sc_ca_dict,
			    rule->r_value.relayhost.ca_name) == NULL) {
				log_warnx("ca name not found: %s", (yyvsp[0].v.string));
				free((yyvsp[0].v.string));
				YYERROR;
			}
			free((yyvsp[0].v.string));
		}
#line 2472 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 81:
#line 774 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			rule->r_value.relayhost.flags |= F_BACKUP;
			if (strlcpy(rule->r_value.relayhost.hostname, (yyvsp[0].v.string),
				sizeof (rule->r_value.relayhost.hostname))
			    >= sizeof (rule->r_value.relayhost.hostname)) {
				log_warnx("hostname too long: %s", (yyvsp[0].v.string));
				free((yyvsp[0].v.string));
				YYERROR;
			}
			free((yyvsp[0].v.string));
		}
#line 2488 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 82:
#line 785 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			rule->r_value.relayhost.flags |= F_BACKUP;
			(void)strlcpy(rule->r_value.relayhost.hostname,
			    conf->sc_hostname,
			    sizeof (rule->r_value.relayhost.hostname));
		}
#line 2499 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 83:
#line 791 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			rule->r_value.relayhost.flags |= F_STARTTLS;
		}
#line 2507 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 84:
#line 794 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			rule->r_value.relayhost.flags |= F_STARTTLS|F_TLS_VERIFY;
		}
#line 2515 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 88:
#line 804 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			struct table   *t = (yyvsp[0].v.table);

			if (! table_check_use(t, T_DYNAMIC|T_HASH, K_CREDENTIALS)) {
				yyerror("invalid use of table \"%s\" as AUTH parameter",
				    t->t_name);
				YYERROR;
			}
			(void)strlcpy(rule->r_value.relayhost.authtable, t->t_name,
			    sizeof(rule->r_value.relayhost.authtable));
		}
#line 2531 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 89:
#line 815 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			if (!(rule->r_value.relayhost.flags & F_SSL)) {
				yyerror("cannot \"verify\" with insecure protocol");
				YYERROR;
			}
			rule->r_value.relayhost.flags |= F_TLS_VERIFY;
		}
#line 2543 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 93:
#line 829 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			memset(conf->sc_bounce_warn, 0, sizeof conf->sc_bounce_warn);
		}
#line 2551 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 95:
#line 832 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			conf->sc_queue_flags |= QUEUE_COMPRESSION;
		}
#line 2559 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 96:
#line 835 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			conf->sc_queue_flags |= QUEUE_ENCRYPTION;
		}
#line 2567 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 97:
#line 838 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			if (strcasecmp((yyvsp[0].v.string), "stdin") == 0 || strcasecmp((yyvsp[0].v.string), "-") == 0) {
				conf->sc_queue_key = "stdin";
				free((yyvsp[0].v.string));
			}
			else
				conf->sc_queue_key = (yyvsp[0].v.string);
			conf->sc_queue_flags |= QUEUE_ENCRYPTION;
		}
#line 2581 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 98:
#line 847 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			conf->sc_qexpire = delaytonum((yyvsp[0].v.string));
			if (conf->sc_qexpire == -1) {
				yyerror("invalid expire delay: %s", (yyvsp[0].v.string));
				free((yyvsp[0].v.string));
				YYERROR;
			}
			free((yyvsp[0].v.string));
		}
#line 2595 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 99:
#line 856 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			conf->sc_maxsize = (yyvsp[0].v.number);
		}
#line 2603 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 100:
#line 859 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			conf->sc_mta_max_deferred = (yyvsp[0].v.number);
		}
#line 2611 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 103:
#line 864 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			struct mta_limits	*d;

			limits = dict_get(conf->sc_limits_dict, (yyvsp[0].v.string));
			if (limits == NULL) {
				limits = xcalloc(1, sizeof(*limits), "mta_limits");
				dict_xset(conf->sc_limits_dict, (yyvsp[0].v.string), limits);
				d = dict_xget(conf->sc_limits_dict, "default");
				memmove(limits, d, sizeof(*limits));
			}
			free((yyvsp[0].v.string));
		}
#line 2628 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 105:
#line 876 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			limits = dict_get(conf->sc_limits_dict, "default");
		}
#line 2636 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 108:
#line 880 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			memset(&l, 0, sizeof l);
			memset(&listen_opts, 0, sizeof listen_opts);
			listen_opts.family = AF_UNSPEC;
			listen_opts.flags |= F_EXT_DSN;
		}
#line 2647 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 109:
#line 885 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			listen_opts.ifx = (yyvsp[-1].v.string);
			create_listener(conf->sc_listeners, &listen_opts);
		}
#line 2656 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 110:
#line 889 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			if (dict_get(&conf->sc_filters, (yyvsp[0].v.string)) == NULL) {
				yyerror("undefined filter \"%s\"", (yyvsp[0].v.string));
				free((yyvsp[0].v.string));
				YYERROR;
			}
			if (strlcpy(conf->sc_enqueue_filter, (yyvsp[0].v.string),
				sizeof conf->sc_enqueue_filter)
			    >= sizeof conf->sc_enqueue_filter) {
				free((yyvsp[0].v.string));
				YYERROR;
			}
			free((yyvsp[0].v.string));
		}
#line 2675 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 111:
#line 903 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			if (!strcmp((yyvsp[0].v.string), "chain")) {
				free((yyvsp[0].v.string));
				if ((filter = create_filter_chain((yyvsp[-1].v.string))) == NULL) {
					free((yyvsp[-1].v.string));
					YYERROR;
				}
			}
			else {
				if ((filter = create_filter_proc((yyvsp[-1].v.string), (yyvsp[0].v.string))) == NULL) {
					free((yyvsp[-1].v.string));
					free((yyvsp[0].v.string));
					YYERROR;
				}
			}
		}
#line 2696 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 113:
#line 919 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			char buf[HOST_NAME_MAX+1];

			/* if not catchall, check that it is a valid domain */
			if (strcmp((yyvsp[0].v.string), "*") != 0) {
				if (! res_hnok((yyvsp[0].v.string))) {
					yyerror("not a valid domain name: %s", (yyvsp[0].v.string));
					free((yyvsp[0].v.string));
					YYERROR;
				}
			}
			xlowercase(buf, (yyvsp[0].v.string), sizeof(buf));
			free((yyvsp[0].v.string));
			pki = dict_get(conf->sc_pki_dict, buf);
			if (pki == NULL) {
				pki = xcalloc(1, sizeof *pki, "parse:pki");
				(void)strlcpy(pki->pki_name, buf, sizeof(pki->pki_name));
				dict_set(conf->sc_pki_dict, pki->pki_name, pki);
			}
		}
#line 2721 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 115:
#line 939 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			char buf[HOST_NAME_MAX+1];

			/* if not catchall, check that it is a valid domain */
			if (strcmp((yyvsp[0].v.string), "*") != 0) {
				if (! res_hnok((yyvsp[0].v.string))) {
					yyerror("not a valid domain name: %s", (yyvsp[0].v.string));
					free((yyvsp[0].v.string));
					YYERROR;
				}
			}
			xlowercase(buf, (yyvsp[0].v.string), sizeof(buf));
			free((yyvsp[0].v.string));
			sca = dict_get(conf->sc_ca_dict, buf);
			if (sca == NULL) {
				sca = xcalloc(1, sizeof *sca, "parse:ca");
				(void)strlcpy(sca->ca_name, buf, sizeof(sca->ca_name));
				dict_set(conf->sc_ca_dict, sca->ca_name, sca);
			}
		}
#line 2746 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 117:
#line 959 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			env->sc_tls_ciphers = (yyvsp[0].v.string);
		}
#line 2754 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 118:
#line 962 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			env->sc_tls_curve = (yyvsp[0].v.string);
		}
#line 2762 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 120:
#line 968 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			if (!add_filter_arg(filter, (yyvsp[0].v.string))) {
				free((yyvsp[0].v.string));
				YYERROR;
			}
		}
#line 2773 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 122:
#line 976 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			char *p, *backend, *config;

			p = (yyvsp[0].v.string);
			if (*p == '/') {
				backend = "static";
				config = (yyvsp[0].v.string);
			}
			else {
				backend = (yyvsp[0].v.string);
				config = NULL;
				for (p = (yyvsp[0].v.string); *p && *p != ':'; p++)
					;
				if (*p == ':') {
					*p = '\0';
					backend = (yyvsp[0].v.string);
					config  = p+1;
				}
			}
			if (config != NULL && *config != '/') {
				yyerror("invalid backend parameter for table: %s",
				    (yyvsp[-1].v.string));
				free((yyvsp[-1].v.string));
				free((yyvsp[0].v.string));
				YYERROR;
			}
			table = table_create(backend, (yyvsp[-1].v.string), NULL, config);
			if (!table_config(table)) {
				yyerror("invalid configuration file %s for table %s",
				    config, table->t_name);
				free((yyvsp[-1].v.string));
				free((yyvsp[0].v.string));
				YYERROR;
			}
			free((yyvsp[-1].v.string));
			free((yyvsp[0].v.string));
		}
#line 2815 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 123:
#line 1013 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			table = table_create("static", (yyvsp[0].v.string), NULL, NULL);
			free((yyvsp[0].v.string));
		}
#line 2824 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 124:
#line 1016 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			table = NULL;
		}
#line 2832 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 127:
#line 1023 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			table->t_type = T_HASH;
			table_add(table, (yyvsp[-2].v.string), (yyvsp[0].v.string));
			free((yyvsp[-2].v.string));
			free((yyvsp[0].v.string));
		}
#line 2843 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 130:
#line 1035 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			table->t_type = T_LIST;
			table_add(table, (yyvsp[0].v.string), NULL);
			free((yyvsp[0].v.string));
		}
#line 2853 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 133:
#line 1046 "../../smtpd/parse.y" /* yacc.c:1646  */
    { }
#line 2859 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 134:
#line 1047 "../../smtpd/parse.y" /* yacc.c:1646  */
    { }
#line 2865 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 135:
#line 1050 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			struct table	*t;

			t = table_create("static", NULL, NULL, NULL);
			t->t_type = T_LIST;
			table_add(t, (yyvsp[0].v.string), NULL);
			free((yyvsp[0].v.string));
			(yyval.v.table) = t;
		}
#line 2879 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 136:
#line 1059 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			table = table_create("static", NULL, NULL, NULL);
		}
#line 2887 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 137:
#line 1061 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			(yyval.v.table) = table;
		}
#line 2895 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 138:
#line 1066 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			struct table	*t;

			if ((t = table_find((yyvsp[-1].v.string), NULL)) == NULL) {
				yyerror("no such table: %s", (yyvsp[-1].v.string));
				free((yyvsp[-1].v.string));
				YYERROR;
			}
			free((yyvsp[-1].v.string));
			(yyval.v.table) = t;
		}
#line 2911 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 139:
#line 1079 "../../smtpd/parse.y" /* yacc.c:1646  */
    { (yyval.v.table) = (yyvsp[0].v.table); }
#line 2917 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 140:
#line 1080 "../../smtpd/parse.y" /* yacc.c:1646  */
    { (yyval.v.table) = (yyvsp[0].v.table); }
#line 2923 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 141:
#line 1083 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			struct table   *t = (yyvsp[0].v.table);

			if (! table_check_use(t, T_DYNAMIC|T_HASH, K_ALIAS)) {
				yyerror("invalid use of table \"%s\" as ALIAS parameter",
				    t->t_name);
				YYERROR;
			}

			(yyval.v.table) = t;
		}
#line 2939 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 142:
#line 1096 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			struct table   *t = (yyvsp[0].v.table);

			if (! table_check_use(t, T_DYNAMIC|T_HASH, K_ALIAS)) {
				yyerror("invalid use of table \"%s\" as VIRTUAL parameter",
				    t->t_name);
				YYERROR;
			}
			(yyval.v.table) = t;
		}
#line 2954 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 143:
#line 1108 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			if (rule->r_mapping) {
				yyerror("alias specified multiple times");
				YYERROR;
			}
			rule->r_desttype = DEST_DOM;
			rule->r_mapping = (yyvsp[0].v.table);
		}
#line 2967 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 144:
#line 1116 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			if (rule->r_mapping) {
				yyerror("virtual specified multiple times");
				YYERROR;
			}
			rule->r_desttype = DEST_VDOM;
			rule->r_mapping = (yyvsp[0].v.table);
		}
#line 2980 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 145:
#line 1126 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			struct table   *t = (yyvsp[0].v.table);

			if (rule->r_userbase) {
				yyerror("userbase specified multiple times");
				YYERROR;
			}
			if (! table_check_use(t, T_DYNAMIC|T_HASH, K_USERINFO)) {
				yyerror("invalid use of table \"%s\" as USERBASE parameter",
				    t->t_name);
				YYERROR;
			}
			rule->r_userbase = t;
		}
#line 2999 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 146:
#line 1142 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			if (strlcpy(rule->r_delivery_user, (yyvsp[0].v.string), sizeof(rule->r_delivery_user))
			    >= sizeof(rule->r_delivery_user))
				fatal("username too long");
			free((yyvsp[0].v.string));
		}
#line 3010 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 147:
#line 1148 "../../smtpd/parse.y" /* yacc.c:1646  */
    { }
#line 3016 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 148:
#line 1151 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			rule->r_action = A_MAILDIR;
			if (strlcpy(rule->r_value.buffer, "~/Maildir",
			    sizeof(rule->r_value.buffer)) >=
			    sizeof(rule->r_value.buffer))
				fatal("pathname too long");
		}
#line 3028 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 149:
#line 1158 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			rule->r_action = A_MAILDIR;
			if (strlcpy(rule->r_value.buffer, (yyvsp[0].v.string),
			    sizeof(rule->r_value.buffer)) >=
			    sizeof(rule->r_value.buffer))
				fatal("pathname too long");
			free((yyvsp[0].v.string));
		}
#line 3041 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 150:
#line 1166 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			rule->r_action = A_MBOX;
			if (strlcpy(rule->r_value.buffer, _PATH_MAILDIR "/%u",
			    sizeof(rule->r_value.buffer))
			    >= sizeof(rule->r_value.buffer))
				fatal("pathname too long");
		}
#line 3053 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 151:
#line 1173 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			rule->r_action = A_LMTP;
			if (strchr((yyvsp[-1].v.string), ':') || (yyvsp[-1].v.string)[0] == '/') {
				if (strlcpy(rule->r_value.buffer, (yyvsp[-1].v.string),
					sizeof(rule->r_value.buffer))
					>= sizeof(rule->r_value.buffer))
					fatal("lmtp destination too long");
			} else
				fatal("invalid lmtp destination");
			free((yyvsp[-1].v.string));
		}
#line 3069 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 152:
#line 1184 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			rule->r_action = A_MDA;
			if (strlcpy(rule->r_value.buffer, (yyvsp[-1].v.string),
			    sizeof(rule->r_value.buffer))
			    >= sizeof(rule->r_value.buffer))
				fatal("command too long");
			free((yyvsp[-1].v.string));
		}
#line 3082 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 153:
#line 1194 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			rule->r_action = A_RELAY;
		}
#line 3090 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 154:
#line 1197 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			rule->r_action = A_RELAYVIA;
			if (! text_to_relayhost(&rule->r_value.relayhost, (yyvsp[0].v.string))) {
				yyerror("error: invalid url: %s", (yyvsp[0].v.string));
				free((yyvsp[0].v.string));
				YYERROR;
			}
			free((yyvsp[0].v.string));
		}
#line 3104 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 155:
#line 1205 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			/* no worries, F_AUTH cant be set without SSL */
			if (rule->r_value.relayhost.flags & F_AUTH) {
				if (rule->r_value.relayhost.authtable[0] == '\0') {
					yyerror("error: auth without auth table");
					YYERROR;
				}
			}
		}
#line 3118 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 156:
#line 1216 "../../smtpd/parse.y" /* yacc.c:1646  */
    { (yyval.v.number) = 1; }
#line 3124 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 157:
#line 1217 "../../smtpd/parse.y" /* yacc.c:1646  */
    { (yyval.v.number) = 0; }
#line 3130 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 158:
#line 1220 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			struct table   *t = (yyvsp[0].v.table);

			if (rule->r_sources) {
				yyerror("from specified multiple times");
				YYERROR;
			}
			if (! table_check_use(t, T_DYNAMIC|T_LIST, K_NETADDR)) {
				yyerror("invalid use of table \"%s\" as FROM parameter",
				    t->t_name);
				YYERROR;
			}
			rule->r_notsources = (yyvsp[-2].v.number);
			rule->r_sources = t;
		}
#line 3150 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 159:
#line 1235 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			if (rule->r_sources) {
				yyerror("from specified multiple times");
				YYERROR;
			}
			rule->r_sources = table_find("<anyhost>", NULL);
			rule->r_notsources = (yyvsp[-1].v.number);
		}
#line 3163 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 160:
#line 1243 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			if (rule->r_sources) {
				yyerror("from specified multiple times");
				YYERROR;
			}
			rule->r_sources = table_find("<localhost>", NULL);
			rule->r_notsources = (yyvsp[-1].v.number);
		}
#line 3176 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 161:
#line 1253 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			struct table   *t = (yyvsp[0].v.table);

			if (rule->r_destination) {
				yyerror("for specified multiple times");
				YYERROR;
			}
			if (! table_check_use(t, T_DYNAMIC|T_LIST, K_DOMAIN)) {
				yyerror("invalid use of table \"%s\" as DOMAIN parameter",
				    t->t_name);
				YYERROR;
			}
			rule->r_notdestination = (yyvsp[-2].v.number);
			rule->r_destination = t;
		}
#line 3196 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 162:
#line 1268 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			if (rule->r_destination) {
				yyerror("for specified multiple times");
				YYERROR;
			}
			rule->r_notdestination = (yyvsp[-1].v.number);
			rule->r_destination = table_find("<anydestination>", NULL);
		}
#line 3209 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 163:
#line 1276 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			if (rule->r_destination) {
				yyerror("for specified multiple times");
				YYERROR;
			}
			rule->r_notdestination = (yyvsp[-1].v.number);
			rule->r_destination = table_find("<localnames>", NULL);
		}
#line 3222 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 164:
#line 1286 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			struct table   *t = (yyvsp[0].v.table);

			if (rule->r_senders) {
				yyerror("sender specified multiple times");
				YYERROR;
			}

			if (! table_check_use(t, T_DYNAMIC|T_LIST, K_MAILADDR)) {
				yyerror("invalid use of table \"%s\" as SENDER parameter",
				    t->t_name);
				YYERROR;
			}
			rule->r_notsenders = (yyvsp[-1].v.number);
			rule->r_senders = t;
		}
#line 3243 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 165:
#line 1304 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			struct table   *t = (yyvsp[0].v.table);

			if (rule->r_recipients) {
				yyerror("recipient specified multiple times");
				YYERROR;
			}

			if (! table_check_use(t, T_DYNAMIC|T_LIST, K_MAILADDR)) {
				yyerror("invalid use of table \"%s\" as RECIPIENT parameter",
				    t->t_name);
				YYERROR;
			}
			rule->r_notrecipients = (yyvsp[-1].v.number);
			rule->r_recipients = t;
		}
#line 3264 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 166:
#line 1322 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			if (rule->r_forwardonly) {
				yyerror("forward-only specified multiple times");
				YYERROR;
			}
			rule->r_forwardonly = 1;
		}
#line 3276 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 167:
#line 1331 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			if (rule->r_qexpire != -1) {
				yyerror("expire specified multiple times");
				YYERROR;
			}
			rule->r_qexpire = delaytonum((yyvsp[0].v.string));
			if (rule->r_qexpire == -1) {
				yyerror("invalid expire delay: %s", (yyvsp[0].v.string));
				free((yyvsp[0].v.string));
				YYERROR;
			}
			free((yyvsp[0].v.string));
		}
#line 3294 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 186:
#line 1376 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			rule = xcalloc(1, sizeof(*rule), "parse rule: ACCEPT");
			rule->r_action = A_NONE;
			rule->r_decision = R_ACCEPT;
			rule->r_desttype = DEST_DOM;
			rule->r_qexpire = -1;
		}
#line 3306 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 187:
#line 1382 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			if (! rule->r_sources)
				rule->r_sources = table_find("<localhost>", NULL);			
			if (! rule->r_destination)
			 	rule->r_destination = table_find("<localnames>", NULL);
			if (! rule->r_userbase)
				rule->r_userbase = table_find("<getpwnam>", NULL);
			if (rule->r_qexpire == -1)
				rule->r_qexpire = conf->sc_qexpire;
			if (rule->r_action == A_RELAY || rule->r_action == A_RELAYVIA) {
				if (rule->r_userbase != table_find("<getpwnam>", NULL)) {
					yyerror("userbase may not be used with a relay rule");
					YYERROR;
				}
				if (rule->r_mapping) {
					yyerror("aliases/virtual may not be used with a relay rule");
					YYERROR;
				}
			}
			if (rule->r_forwardonly && rule->r_action != A_NONE) {
				yyerror("forward-only may not be used with a default action");
				YYERROR;
			}
			TAILQ_INSERT_TAIL(conf->sc_rules, rule, r_entry);
			rule = NULL;
		}
#line 3337 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 188:
#line 1408 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			rule = xcalloc(1, sizeof(*rule), "parse rule: REJECT");
			rule->r_decision = R_REJECT;
			rule->r_desttype = DEST_DOM;
		}
#line 3347 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;

  case 189:
#line 1412 "../../smtpd/parse.y" /* yacc.c:1646  */
    {
			if (! rule->r_sources)
				rule->r_sources = table_find("<localhost>", NULL);
			if (! rule->r_destination)
				rule->r_destination = table_find("<localnames>", NULL);
			TAILQ_INSERT_TAIL(conf->sc_rules, rule, r_entry);
			rule = NULL;
		}
#line 3360 "../../smtpd/parse.c" /* yacc.c:1646  */
    break;


#line 3364 "../../smtpd/parse.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 1421 "../../smtpd/parse.y" /* yacc.c:1906  */


struct keywords {
	const char	*k_name;
	int		 k_val;
};

int
yyerror(const char *fmt, ...)
{
	va_list ap;
	char*msg;

	file->errors++;
	va_start(ap, fmt);
	if (vasprintf(&msg, fmt, ap) == -1)
		fatalx("yyerror vasprintf");
	va_end(ap);
	logit(LOG_CRIT, "%s:%d: %s", file->name, yylval.lineno, msg);
	free(msg);
	return (0);
}

int
kw_cmp(const void *k, const void *e)
{
	return (strcmp(k, ((const struct keywords *)e)->k_name));
}

int
lookup(char *s)
{
	/* this has to be sorted always */
	static const struct keywords keywords[] = {
		{ "accept",		ACCEPT },
		{ "alias",		ALIAS },
		{ "any",		ANY },
		{ "as",			AS },
		{ "auth",		AUTH },
		{ "auth-optional",     	AUTH_OPTIONAL },
		{ "backup",		BACKUP },
		{ "bounce-warn",	BOUNCEWARN },
		{ "ca",			CA },
		{ "certificate",	CERTIFICATE },
		{ "ciphers",		CIPHERS },
		{ "compression",	COMPRESSION },
		{ "curve",		CURVE },
		{ "deliver",		DELIVER },
		{ "dhparams",		DHPARAMS },
		{ "disable",		DISABLE },
		{ "domain",		DOMAIN },
		{ "dsn-notify",		DSNNOTIFY },
		{ "dsn-ret",		DSNRET },
		{ "encryption",		ENCRYPTION },
		{ "enqueuer",		ENQUEUER },
		{ "expire",		EXPIRE },
		{ "filter",		FILTER },
		{ "for",		FOR },
		{ "forward-only",      	FORWARDONLY },
		{ "from",		FROM },
		{ "headers",		HEADERS },
		{ "hostname",		HOSTNAME },
		{ "hostnames",		HOSTNAMES },
		{ "include",		INCLUDE },
		{ "inet4",		INET4 },
		{ "inet6",		INET6 },
		{ "key",		KEY },
		{ "limit",		LIMIT },
		{ "listen",		LISTEN },
		{ "lmtp",		LMTP },
		{ "local",		LOCAL },
		{ "maildir",		MAILDIR },
		{ "mask-source",	MASK_SOURCE },
		{ "masquerade",		MASQUERADE },
		{ "max-message-size",  	MAXMESSAGESIZE },
		{ "max-mta-deferred",  	MAXMTADEFERRED },
		{ "mbox",		MBOX },
		{ "mda",		MDA },
		{ "mta",		MTA },
		{ "no-dsn",		NODSN },
		{ "on",			ON },
		{ "pki",		PKI },
		{ "port",		PORT },
		{ "queue",		QUEUE },
		{ "received-auth",     	RECEIVEDAUTH },
		{ "recipient",		RECIPIENT },
		{ "reject",		REJECT },
		{ "relay",		RELAY },
		{ "scheduler",		SCHEDULER },
		{ "secure",		SECURE },
		{ "sender",    		SENDER },
		{ "senders",   		SENDERS },
		{ "session",   		SESSION },
		{ "smtps",		SMTPS },
		{ "source",		SOURCE },
		{ "table",		TABLE },
		{ "tag",		TAG },
		{ "tagged",		TAGGED },
		{ "tls",		TLS },
		{ "tls-require",       	TLS_REQUIRE },
		{ "to",			TO },
		{ "userbase",		USERBASE },
		{ "verify",		VERIFY },
		{ "via",		VIA },
		{ "virtual",		VIRTUAL },
	};
	const struct keywords	*p;

	p = bsearch(s, keywords, sizeof(keywords)/sizeof(keywords[0]),
	    sizeof(keywords[0]), kw_cmp);

	if (p)
		return (p->k_val);
	else
		return (STRING);
}

#define MAXPUSHBACK	128

u_char	*parsebuf;
int	 parseindex;
u_char	 pushback_buffer[MAXPUSHBACK];
int	 pushback_index = 0;

int
lgetc(int quotec)
{
	int		c, next;

	if (parsebuf) {
		/* Read character from the parsebuffer instead of input. */
		if (parseindex >= 0) {
			c = parsebuf[parseindex++];
			if (c != '\0')
				return (c);
			parsebuf = NULL;
		} else
			parseindex++;
	}

	if (pushback_index)
		return (pushback_buffer[--pushback_index]);

	if (quotec) {
		if ((c = getc(file->stream)) == EOF) {
			yyerror("reached end of file while parsing "
			    "quoted string");
			if (file == topfile || popfile() == EOF)
				return (EOF);
			return (quotec);
		}
		return (c);
	}

	while ((c = getc(file->stream)) == '\\') {
		next = getc(file->stream);
		if (next != '\n') {
			c = next;
			break;
		}
		yylval.lineno = file->lineno;
		file->lineno++;
	}

	while (c == EOF) {
		if (file == topfile || popfile() == EOF)
			return (EOF);
		c = getc(file->stream);
	}
	return (c);
}

int
lungetc(int c)
{
	if (c == EOF)
		return (EOF);
	if (parsebuf) {
		parseindex--;
		if (parseindex >= 0)
			return (c);
	}
	if (pushback_index < MAXPUSHBACK-1)
		return (pushback_buffer[pushback_index++] = c);
	else
		return (EOF);
}

int
findeol(void)
{
	int	c;

	parsebuf = NULL;
	pushback_index = 0;

	/* skip to either EOF or the first real EOL */
	while (1) {
		c = lgetc(0);
		if (c == '\n') {
			file->lineno++;
			break;
		}
		if (c == EOF)
			break;
	}
	return (ERROR);
}

int
yylex(void)
{
	u_char	 buf[8096];
	u_char	*p, *val;
	int	 quotec, next, c;
	int	 token;

top:
	p = buf;
	while ((c = lgetc(0)) == ' ' || c == '\t')
		; /* nothing */

	yylval.lineno = file->lineno;
	if (c == '#')
		while ((c = lgetc(0)) != '\n' && c != EOF)
			; /* nothing */
	if (c == '$' && parsebuf == NULL) {
		while (1) {
			if ((c = lgetc(0)) == EOF)
				return (0);

			if (p + 1 >= buf + sizeof(buf) - 1) {
				yyerror("string too long");
				return (findeol());
			}
			if (isalnum(c) || c == '_') {
				*p++ = c;
				continue;
			}
			*p = '\0';
			lungetc(c);
			break;
		}
		val = symget(buf);
		if (val == NULL) {
			yyerror("macro '%s' not defined", buf);
			return (findeol());
		}
		parsebuf = val;
		parseindex = 0;
		goto top;
	}

	switch (c) {
	case '\'':
	case '"':
		quotec = c;
		while (1) {
			if ((c = lgetc(quotec)) == EOF)
				return (0);
			if (c == '\n') {
				file->lineno++;
				continue;
			} else if (c == '\\') {
				if ((next = lgetc(quotec)) == EOF)
					return (0);
				if (next == quotec || c == ' ' || c == '\t')
					c = next;
				else if (next == '\n') {
					file->lineno++;
					continue;
				} else
					lungetc(next);
			} else if (c == quotec) {
				*p = '\0';
				break;
			} else if (c == '\0') {
				yyerror("syntax error");
				return (findeol());
			}
			if (p + 1 >= buf + sizeof(buf) - 1) {
				yyerror("string too long");
				return (findeol());
			}
			*p++ = c;
		}
		yylval.v.string = strdup(buf);
		if (yylval.v.string == NULL)
			err(1, "yylex: strdup");
		return (STRING);
	}

#define allowed_to_end_number(x) \
	(isspace(x) || x == ')' || x ==',' || x == '/' || x == '}' || x == '=')

	if (c == '-' || isdigit(c)) {
		do {
			*p++ = c;
			if ((unsigned)(p-buf) >= sizeof(buf)) {
				yyerror("string too long");
				return (findeol());
			}
		} while ((c = lgetc(0)) != EOF && isdigit(c));
		lungetc(c);
		if (p == buf + 1 && buf[0] == '-')
			goto nodigits;
		if (c == EOF || allowed_to_end_number(c)) {
			const char *errstr = NULL;

			*p = '\0';
			yylval.v.number = strtonum(buf, LLONG_MIN,
			    LLONG_MAX, &errstr);
			if (errstr) {
				yyerror("\"%s\" invalid number: %s",
				    buf, errstr);
				return (findeol());
			}
			return (NUMBER);
		} else {
nodigits:
			while (p > buf + 1)
				lungetc(*--p);
			c = *--p;
			if (c == '-')
				return (c);
		}
	}

	if (c == '=') {
		if ((c = lgetc(0)) != EOF && c == '>')
			return (ARROW);
		lungetc(c);
		c = '=';
	}

#define allowed_in_string(x) \
	(isalnum(x) || (ispunct(x) && x != '(' && x != ')' && \
	x != '{' && x != '}' && x != '<' && x != '>' && \
	x != '!' && x != '=' && x != '#' && \
	x != ','))

	if (isalnum(c) || c == ':' || c == '_') {
		do {
			*p++ = c;
			if ((unsigned)(p-buf) >= sizeof(buf)) {
				yyerror("string too long");
				return (findeol());
			}
		} while ((c = lgetc(0)) != EOF && (allowed_in_string(c)));
		lungetc(c);
		*p = '\0';
		if ((token = lookup(buf)) == STRING)
			if ((yylval.v.string = strdup(buf)) == NULL)
				err(1, "yylex: strdup");
		return (token);
	}
	if (c == '\n') {
		yylval.lineno = file->lineno;
		file->lineno++;
	}
	if (c == EOF)
		return (0);
	return (c);
}

int
check_file_secrecy(int fd, const char *fname)
{
	struct stat	st;

	if (fstat(fd, &st)) {
		log_warn("warn: cannot stat %s", fname);
		return (-1);
	}
	if (st.st_uid != 0 && st.st_uid != getuid()) {
		log_warnx("warn: %s: owner not root or current user", fname);
		return (-1);
	}
	if (st.st_mode & (S_IWGRP | S_IXGRP | S_IRWXO)) {
		log_warnx("warn: %s: group/world readable/writeable", fname);
		return (-1);
	}
	return (0);
}

struct file *
pushfile(const char *name, int secret)
{
	struct file	*nfile;

	if ((nfile = calloc(1, sizeof(struct file))) == NULL) {
		log_warn("warn: malloc");
		return (NULL);
	}
	if ((nfile->name = strdup(name)) == NULL) {
		log_warn("warn: malloc");
		free(nfile);
		return (NULL);
	}
	if ((nfile->stream = fopen(nfile->name, "r")) == NULL) {
		log_warn("warn: %s", nfile->name);
		free(nfile->name);
		free(nfile);
		return (NULL);
	} else if (secret &&
	    check_file_secrecy(fileno(nfile->stream), nfile->name)) {
		fclose(nfile->stream);
		free(nfile->name);
		free(nfile);
		return (NULL);
	}
	nfile->lineno = 1;
	TAILQ_INSERT_TAIL(&files, nfile, entry);
	return (nfile);
}

int
popfile(void)
{
	struct file	*prev;

	if ((prev = TAILQ_PREV(file, files, entry)) != NULL)
		prev->errors += file->errors;

	TAILQ_REMOVE(&files, file, entry);
	fclose(file->stream);
	free(file->name);
	free(file);
	file = prev;
	return (file ? 0 : EOF);
}

int
parse_config(struct smtpd *x_conf, const char *filename, int opts)
{
	struct sym     *sym, *next;
	struct table   *t;
	char		hostname[HOST_NAME_MAX+1];
	char		hostname_copy[HOST_NAME_MAX+1];

	if (! getmailname(hostname, sizeof hostname))
		return (-1);

	conf = x_conf;
	memset(conf, 0, sizeof(*conf));

	(void)strlcpy(conf->sc_hostname, hostname, sizeof(conf->sc_hostname));

	conf->sc_maxsize = DEFAULT_MAX_BODY_SIZE;

	conf->sc_tables_dict = calloc(1, sizeof(*conf->sc_tables_dict));
	conf->sc_rules = calloc(1, sizeof(*conf->sc_rules));
	conf->sc_listeners = calloc(1, sizeof(*conf->sc_listeners));
	conf->sc_ca_dict = calloc(1, sizeof(*conf->sc_ca_dict));
	conf->sc_pki_dict = calloc(1, sizeof(*conf->sc_pki_dict));
	conf->sc_ssl_dict = calloc(1, sizeof(*conf->sc_ssl_dict));
	conf->sc_limits_dict = calloc(1, sizeof(*conf->sc_limits_dict));

	/* Report mails delayed for more than 4 hours */
	conf->sc_bounce_warn[0] = 3600 * 4;

	if (conf->sc_tables_dict == NULL	||
	    conf->sc_rules == NULL		||
	    conf->sc_listeners == NULL		||
	    conf->sc_ca_dict == NULL		||
	    conf->sc_pki_dict == NULL		||
	    conf->sc_ssl_dict == NULL		||
	    conf->sc_limits_dict == NULL) {
		log_warn("warn: cannot allocate memory");
		free(conf->sc_tables_dict);
		free(conf->sc_rules);
		free(conf->sc_listeners);
		free(conf->sc_ca_dict);
		free(conf->sc_pki_dict);
		free(conf->sc_ssl_dict);
		free(conf->sc_limits_dict);
		return (-1);
	}

	errors = 0;

	table = NULL;
	rule = NULL;

	dict_init(&conf->sc_filters);

	dict_init(conf->sc_ca_dict);
	dict_init(conf->sc_pki_dict);
	dict_init(conf->sc_ssl_dict);
	dict_init(conf->sc_tables_dict);

	dict_init(conf->sc_limits_dict);
	limits = xcalloc(1, sizeof(*limits), "mta_limits");
	limit_mta_set_defaults(limits);
	dict_xset(conf->sc_limits_dict, "default", limits);

	TAILQ_INIT(conf->sc_listeners);
	TAILQ_INIT(conf->sc_rules);

	conf->sc_qexpire = SMTPD_QUEUE_EXPIRY;
	conf->sc_opts = opts;

	conf->sc_mta_max_deferred = 100;
	conf->sc_scheduler_max_inflight = 5000;
	conf->sc_scheduler_max_schedule = 10;
	conf->sc_scheduler_max_evp_batch_size = 256;
	conf->sc_scheduler_max_msg_batch_size = 1024;
	
	conf->sc_session_max_rcpt = 1000;
	conf->sc_session_max_mails = 100;

	conf->sc_mda_max_session = 50;
	conf->sc_mda_max_user_session = 7;
	conf->sc_mda_task_hiwat = 50;
	conf->sc_mda_task_lowat = 30;
	conf->sc_mda_task_release = 10;

	if ((file = pushfile(filename, 0)) == NULL) {
		purge_config(PURGE_EVERYTHING);
		return (-1);
	}
	topfile = file;

	/*
	 * declare special "localhost", "anyhost" and "localnames" tables
	 */
	set_local(hostname);

	t = table_create("static", "<anydestination>", NULL, NULL);
	t->t_type = T_LIST;
	table_add(t, "*", NULL);

	/* can't truncate here */
	(void)strlcpy(hostname_copy, hostname, sizeof hostname_copy);

	hostname_copy[strcspn(hostname_copy, ".")] = '\0';
	if (strcmp(hostname, hostname_copy) != 0)
		table_add(t, hostname_copy, NULL);

	table_create("getpwnam", "<getpwnam>", NULL, NULL);

	/*
	 * parse configuration
	 */
	setservent(1);
	yyparse();
	errors = file->errors;
	popfile();
	endservent();

	/* Free macros and check which have not been used. */
	for (sym = TAILQ_FIRST(&symhead); sym != NULL; sym = next) {
		next = TAILQ_NEXT(sym, entry);
		if ((conf->sc_opts & SMTPD_OPT_VERBOSE) && !sym->used)
			fprintf(stderr, "warning: macro '%s' not "
			    "used\n", sym->nam);
		if (!sym->persist) {
			free(sym->nam);
			free(sym->val);
			TAILQ_REMOVE(&symhead, sym, entry);
			free(sym);
		}
	}

	if (TAILQ_EMPTY(conf->sc_rules)) {
		log_warnx("warn: no rules, nothing to do");
		errors++;
	}

	if (errors) {
		purge_config(PURGE_EVERYTHING);
		return (-1);
	}

	return (0);
}

int
symset(const char *nam, const char *val, int persist)
{
	struct sym	*sym;

	for (sym = TAILQ_FIRST(&symhead); sym && strcmp(nam, sym->nam);
	    sym = TAILQ_NEXT(sym, entry))
		;	/* nothing */

	if (sym != NULL) {
		if (sym->persist == 1)
			return (0);
		else {
			free(sym->nam);
			free(sym->val);
			TAILQ_REMOVE(&symhead, sym, entry);
			free(sym);
		}
	}
	if ((sym = calloc(1, sizeof(*sym))) == NULL)
		return (-1);

	sym->nam = strdup(nam);
	if (sym->nam == NULL) {
		free(sym);
		return (-1);
	}
	sym->val = strdup(val);
	if (sym->val == NULL) {
		free(sym->nam);
		free(sym);
		return (-1);
	}
	sym->used = 0;
	sym->persist = persist;
	TAILQ_INSERT_TAIL(&symhead, sym, entry);
	return (0);
}

int
cmdline_symset(char *s)
{
	char	*sym, *val;
	int	ret;
	size_t	len;

	if ((val = strrchr(s, '=')) == NULL)
		return (-1);

	len = strlen(s) - strlen(val) + 1;
	if ((sym = malloc(len)) == NULL)
		errx(1, "cmdline_symset: malloc");

	(void)strlcpy(sym, s, len);

	ret = symset(sym, val + 1, 1);
	free(sym);

	return (ret);
}

char *
symget(const char *nam)
{
	struct sym	*sym;

	TAILQ_FOREACH(sym, &symhead, entry)
		if (strcmp(nam, sym->nam) == 0) {
			sym->used = 1;
			return (sym->val);
		}
	return (NULL);
}

static void
create_listener(struct listenerlist *ll,  struct listen_opts *lo)
{
	uint16_t	flags;

	if (lo->port != 0 && lo->ssl == F_SSL)
		errx(1, "invalid listen option: tls/smtps on same port");
	
	if (lo->auth != 0 && !lo->ssl)
		errx(1, "invalid listen option: auth requires tls/smtps");
	
	if (lo->pki && !lo->ssl)
		errx(1, "invalid listen option: pki requires tls/smtps");

	flags = lo->flags;

	if (lo->port) {
		lo->flags = lo->ssl|lo->auth|flags;
		lo->port = htons(lo->port);
		if (! interface(ll, lo))
			if (host(ll, lo) <= 0)
				errx(1, "invalid virtual ip or interface: %s", lo->ifx);
	}
	else {
		if (lo->ssl & F_SMTPS) {
			lo->port = htons(465);
			lo->flags = F_SMTPS|lo->auth|flags;
			if (! interface(ll, lo))
				if (host(ll, lo) <= 0)
					errx(1, "invalid virtual ip or interface: %s", lo->ifx);
		}

		if (! lo->ssl || (lo->ssl & F_STARTTLS)) {
			lo->port = htons(25);
			lo->flags = lo->auth|flags;
			if (lo->ssl & F_STARTTLS)
				lo->flags |= F_STARTTLS;
			if (! interface(ll, lo))
				if (host(ll, lo) <= 0)
					errx(1, "invalid virtual ip or interface: %s", lo->ifx);
		}
	}
}

static void
config_listener(struct listener *h,  struct listen_opts *lo)
{
	h->fd = -1;
	h->port = lo->port;
	h->flags = lo->flags;

	if (lo->hostname == NULL)
		lo->hostname = conf->sc_hostname;

	if (lo->filtername) {
		if (dict_get(&conf->sc_filters, lo->filtername) == NULL) {
			log_warnx("undefined filter: %s", lo->filtername);
			fatalx(NULL);
		}
		(void)strlcpy(h->filter, lo->filtername, sizeof(h->filter));
	}

	h->pki_name[0] = '\0';

	if (lo->authtable != NULL)
		(void)strlcpy(h->authtable, lo->authtable->t_name, sizeof(h->authtable));
	if (lo->pki != NULL) {
		if (! lowercase(h->pki_name, lo->pki, sizeof(h->pki_name))) {
			log_warnx("pki name too long: %s", lo->pki);
			fatalx(NULL);
		}
		if (dict_get(conf->sc_pki_dict, h->pki_name) == NULL) {
			log_warnx("pki name not found: %s", lo->pki);
			fatalx(NULL);
		}
	}
	if (lo->ca != NULL) {
		if (! lowercase(h->ca_name, lo->ca, sizeof(h->ca_name))) {
			log_warnx("ca name too long: %s", lo->ca);
			fatalx(NULL);
		}
		if (dict_get(conf->sc_ca_dict, h->ca_name) == NULL) {
			log_warnx("ca name not found: %s", lo->ca);
			fatalx(NULL);
		}
	}
	if (lo->tag != NULL)
		(void)strlcpy(h->tag, lo->tag, sizeof(h->tag));

	(void)strlcpy(h->hostname, lo->hostname, sizeof(h->hostname));
	if (lo->hostnametable)
		(void)strlcpy(h->hostnametable, lo->hostnametable->t_name, sizeof(h->hostnametable));
	if (lo->sendertable) {
		(void)strlcpy(h->sendertable, lo->sendertable->t_name, sizeof(h->sendertable));
		if (lo->options & LO_MASQUERADE)
			h->flags |= F_MASQUERADE;
	}

	if (lo->ssl & F_TLS_VERIFY)
		h->flags |= F_TLS_VERIFY;
}

struct listener *
host_v4(const char *s, in_port_t port)
{
	struct in_addr		 ina;
	struct sockaddr_in	*sain;
	struct listener		*h;

	memset(&ina, 0, sizeof(ina));
	if (inet_pton(AF_INET, s, &ina) != 1)
		return (NULL);

	h = xcalloc(1, sizeof(*h), "host_v4");
	sain = (struct sockaddr_in *)&h->ss;
#ifdef HAVE_STRUCT_SOCKADDR_IN_SIN_LEN
	sain->sin_len = sizeof(struct sockaddr_in);
#endif
	sain->sin_family = AF_INET;
	sain->sin_addr.s_addr = ina.s_addr;
	sain->sin_port = port;

	return (h);
}

struct listener *
host_v6(const char *s, in_port_t port)
{
	struct in6_addr		 ina6;
	struct sockaddr_in6	*sin6;
	struct listener		*h;

	memset(&ina6, 0, sizeof(ina6));
	if (inet_pton(AF_INET6, s, &ina6) != 1)
		return (NULL);

	h = xcalloc(1, sizeof(*h), "host_v6");
	sin6 = (struct sockaddr_in6 *)&h->ss;
#ifdef HAVE_STRUCT_SOCKADDR_IN6_SIN6_LEN
	sin6->sin6_len = sizeof(struct sockaddr_in6);
#endif
	sin6->sin6_family = AF_INET6;
	sin6->sin6_port = port;
	memcpy(&sin6->sin6_addr, &ina6, sizeof(ina6));

	return (h);
}

int
host_dns(struct listenerlist *al, struct listen_opts *lo)
{
	struct addrinfo		 hints, *res0, *res;
	int			 error, cnt = 0;
	struct sockaddr_in	*sain;
	struct sockaddr_in6	*sin6;
	struct listener		*h;

	memset(&hints, 0, sizeof(hints));
	hints.ai_family = PF_UNSPEC;
	hints.ai_socktype = SOCK_STREAM;
	hints.ai_flags = AI_ADDRCONFIG;
	error = getaddrinfo(lo->ifx, NULL, &hints, &res0);
	if (error == EAI_AGAIN || error == EAI_NODATA || error == EAI_NONAME)
		return (0);
	if (error) {
		log_warnx("warn: host_dns: could not parse \"%s\": %s", lo->ifx,
		    gai_strerror(error));
		return (-1);
	}

	for (res = res0; res; res = res->ai_next) {
		if (res->ai_family != AF_INET &&
		    res->ai_family != AF_INET6)
			continue;
		h = xcalloc(1, sizeof(*h), "host_dns");

		h->ss.ss_family = res->ai_family;
		if (res->ai_family == AF_INET) {
			sain = (struct sockaddr_in *)&h->ss;
#ifdef HAVE_STRUCT_SOCKADDR_IN_SIN_LEN
			sain->sin_len = sizeof(struct sockaddr_in);
#endif
			sain->sin_addr.s_addr = ((struct sockaddr_in *)
			    res->ai_addr)->sin_addr.s_addr;
			sain->sin_port = lo->port;
		} else {
			sin6 = (struct sockaddr_in6 *)&h->ss;
#ifdef HAVE_STRUCT_SOCKADDR_IN6_SIN6_LEN
			sin6->sin6_len = sizeof(struct sockaddr_in6);
#endif
			memcpy(&sin6->sin6_addr, &((struct sockaddr_in6 *)
			    res->ai_addr)->sin6_addr, sizeof(struct in6_addr));
			sin6->sin6_port = lo->port;
		}

		config_listener(h, lo);

		TAILQ_INSERT_HEAD(al, h, entry);
		cnt++;
	}

	freeaddrinfo(res0);
	return (cnt);
}

int
host(struct listenerlist *al, struct listen_opts *lo)
{
	struct listener *h;

	h = host_v4(lo->ifx, lo->port);

	/* IPv6 address? */
	if (h == NULL)
		h = host_v6(lo->ifx, lo->port);

	if (h != NULL) {
		config_listener(h, lo);
		TAILQ_INSERT_HEAD(al, h, entry);
		return (1);
	}

	return (host_dns(al, lo));
}

int
interface(struct listenerlist *al, struct listen_opts *lo)
{
	struct ifaddrs *ifap, *p;
	struct sockaddr_in	*sain;
	struct sockaddr_in6	*sin6;
	struct listener		*h;
	int			ret = 0;

	if (getifaddrs(&ifap) == -1)
		fatal("getifaddrs");

	for (p = ifap; p != NULL; p = p->ifa_next) {
		if (p->ifa_addr == NULL)
			continue;
		if (strcmp(p->ifa_name, lo->ifx) != 0 &&
		    ! is_if_in_group(p->ifa_name, lo->ifx))
			continue;
		if (lo->family != AF_UNSPEC && lo->family != p->ifa_addr->sa_family)
			continue;

		h = xcalloc(1, sizeof(*h), "interface");

		switch (p->ifa_addr->sa_family) {
		case AF_INET:
			sain = (struct sockaddr_in *)&h->ss;
			*sain = *(struct sockaddr_in *)p->ifa_addr;
#ifdef HAVE_STRUCT_SOCKADDR_IN_SIN_LEN
			sain->sin_len = sizeof(struct sockaddr_in);
#endif
			sain->sin_port = lo->port;
			break;

		case AF_INET6:
			sin6 = (struct sockaddr_in6 *)&h->ss;
			*sin6 = *(struct sockaddr_in6 *)p->ifa_addr;
#ifdef HAVE_STRUCT_SOCKADDR_IN6_SIN6_LEN
			sin6->sin6_len = sizeof(struct sockaddr_in6);
#endif
			sin6->sin6_port = lo->port;
			break;

		default:
			free(h);
			continue;
		}

		config_listener(h, lo);
		ret = 1;
		TAILQ_INSERT_HEAD(al, h, entry);
	}

	freeifaddrs(ifap);

	return ret;
}

void
set_local(const char *hostname)
{
	struct table	*t;

	t = table_create("static", "<localnames>", NULL, NULL);
	t->t_type = T_LIST;
	table_add(t, "localhost", NULL);
	table_add(t, hostname, NULL);

	set_localaddrs(t);
}

void
set_localaddrs(struct table *localnames)
{
	struct ifaddrs *ifap, *p;
	struct sockaddr_storage ss;
	struct sockaddr_in	*sain;
	struct sockaddr_in6	*sin6;
	struct table		*t;
	char buf[NI_MAXHOST + 5];

	t = table_create("static", "<anyhost>", NULL, NULL);
	table_add(t, "local", NULL);
	table_add(t, "0.0.0.0/0", NULL);
	table_add(t, "::/0", NULL);

	if (getifaddrs(&ifap) == -1)
		fatal("getifaddrs");

	t = table_create("static", "<localhost>", NULL, NULL);
	table_add(t, "local", NULL);

	for (p = ifap; p != NULL; p = p->ifa_next) {
		if (p->ifa_addr == NULL)
			continue;
		switch (p->ifa_addr->sa_family) {
		case AF_INET:
			sain = (struct sockaddr_in *)&ss;
			*sain = *(struct sockaddr_in *)p->ifa_addr;
#ifdef HAVE_STRUCT_SOCKADDR_IN_SIN_LEN
			sain->sin_len = sizeof(struct sockaddr_in);
#endif
			table_add(t, ss_to_text(&ss), NULL);
			table_add(localnames, ss_to_text(&ss), NULL);
			(void)snprintf(buf, sizeof buf, "[%s]", ss_to_text(&ss));
			table_add(localnames, buf, NULL);
			break;

		case AF_INET6:
			sin6 = (struct sockaddr_in6 *)&ss;
			*sin6 = *(struct sockaddr_in6 *)p->ifa_addr;
#ifdef HAVE_STRUCT_SOCKADDR_IN6_SIN6_LEN
			sin6->sin6_len = sizeof(struct sockaddr_in6);
#endif
			table_add(t, ss_to_text(&ss), NULL);
			table_add(localnames, ss_to_text(&ss), NULL);
			(void)snprintf(buf, sizeof buf, "[%s]", ss_to_text(&ss));
			table_add(localnames, buf, NULL);
			(void)snprintf(buf, sizeof buf, "[ipv6:%s]", ss_to_text(&ss));
			table_add(localnames, buf, NULL);
			break;
		}
	}

	freeifaddrs(ifap);
}

int
delaytonum(char *str)
{
	unsigned int     factor;
	size_t           len;
	const char      *errstr = NULL;
	int              delay;
  	
	/* we need at least 1 digit and 1 unit */
	len = strlen(str);
	if (len < 2)
		goto bad;
	
	switch(str[len - 1]) {
		
	case 's':
		factor = 1;
		break;
		
	case 'm':
		factor = 60;
		break;
		
	case 'h':
		factor = 60 * 60;
		break;
		
	case 'd':
		factor = 24 * 60 * 60;
		break;
		
	default:
		goto bad;
	}
  	
	str[len - 1] = '\0';
	delay = strtonum(str, 1, INT_MAX / factor, &errstr);
	if (errstr)
		goto bad;
	
	return (delay * factor);
  	
bad:
	return (-1);
}

int
is_if_in_group(const char *ifname, const char *groupname)
{
#ifdef HAVE_STRUCT_IFGROUPREQ
        unsigned int		 len;
        struct ifgroupreq        ifgr;
        struct ifg_req          *ifg;
	int			 s;
	int			 ret = 0;

	if ((s = socket(AF_INET, SOCK_DGRAM, 0)) < 0)
		err(1, "socket");

        memset(&ifgr, 0, sizeof(ifgr));
        if (strlcpy(ifgr.ifgr_name, ifname, IFNAMSIZ) >= IFNAMSIZ)
		errx(1, "interface name too large");

        if (ioctl(s, SIOCGIFGROUP, (caddr_t)&ifgr) == -1) {
                if (errno == EINVAL || errno == ENOTTY)
			goto end;
		err(1, "SIOCGIFGROUP");
        }

        len = ifgr.ifgr_len;
        ifgr.ifgr_groups =
            (struct ifg_req *)xcalloc(len/sizeof(struct ifg_req),
		sizeof(struct ifg_req), "is_if_in_group");
        if (ioctl(s, SIOCGIFGROUP, (caddr_t)&ifgr) == -1)
                err(1, "SIOCGIFGROUP");
	
        ifg = ifgr.ifgr_groups;
        for (; ifg && len >= sizeof(struct ifg_req); ifg++) {
                len -= sizeof(struct ifg_req);
		if (strcmp(ifg->ifgrq_group, groupname) == 0) {
			ret = 1;
			break;
		}
        }
        free(ifgr.ifgr_groups);

end:
	close(s);
	return ret;
#else
	return (0);
#endif
}

static struct filter_conf *
create_filter_proc(char *name, char *prog)
{
	struct filter_conf	*f;
	char			*path;

	if (dict_get(&conf->sc_filters, name)) {
		yyerror("filter \"%s\" already defined", name);
		return (NULL);
	}

	if (asprintf(&path, "%s/filter-%s", PATH_LIBEXEC, prog) == -1) {
		yyerror("filter \"%s\" asprintf failed", name);
		return (0);
	}

	f = xcalloc(1, sizeof(*f), "create_filter");
	f->path = path;
	f->name = name;
	f->argv[f->argc++] = name;

	dict_xset(&conf->sc_filters, name, f);

	return (f);
}

static struct filter_conf *
create_filter_chain(char *name)
{
	struct filter_conf	*f;

	if (dict_get(&conf->sc_filters, name)) {
		yyerror("filter \"%s\" already defined", name);
		return (NULL);
	}

	f = xcalloc(1, sizeof(*f), "create_filter_chain");
	f->chain = 1;
	f->name = name;

	dict_xset(&conf->sc_filters, name, f);

	return (f);
}

static int
add_filter_arg(struct filter_conf *f, char *arg)
{
	int	i;

	if (f->argc == MAX_FILTER_ARGS) {
		yyerror("filter \"%s\" is full", f->name);
		return (0);
	}

	if (f->chain) {
		if (dict_get(&conf->sc_filters, arg) == NULL) {
			yyerror("undefined filter \"%s\"", arg);
			return (0);
		}
		if (dict_get(&conf->sc_filters, arg) == f) {
			yyerror("filter chain cannot contain itself");
			return (0);
		}
		for (i = 0; i < f->argc; ++i)
			if (strcasecmp(f->argv[i], arg) == 0) {
				yyerror("filter chain cannot contain twice the same filter instance");
				return (0);
			}
	}

	f->argv[f->argc++] = arg;

	return (1);
}
